-- by (Discord) Unangenehmer#9659 
-- Date 23.10.2020

ExtendedVehicleMaintenance = {};

function ExtendedVehicleMaintenance.prerequisitesPresent(specializations)
	return true;
end;

function ExtendedVehicleMaintenance.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", ExtendedVehicleMaintenance);
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", ExtendedVehicleMaintenance);
end;

function ExtendedVehicleMaintenance:onLoad(savegame)
    self.spec_ExtendedVehicleMaintenance = {};
	if self.spec_motorized ~= nil and self.typeName ~= locomotive then
	    self.spec_ExtendedVehicleMaintenance.gearChangeTimeBackup = {};
	    self.spec_ExtendedVehicleMaintenance.gearChangeTimeBackup = self.spec_motorized.motor.gearChangeTime;
	
	    self.spec_ExtendedVehicleMaintenance.accelerationLimitBackup = {};
	    self.spec_ExtendedVehicleMaintenance.accelerationLimitBackup = self.spec_motorized.motor.accelerationLimit;
	
    	self.spec_ExtendedVehicleMaintenance.torqueCurveBackup = {};
    	self.spec_ExtendedVehicleMaintenance.torqueCurveBackup = self.spec_motorized.motor.torqueCurve.maxTime;
	
	    self.spec_ExtendedVehicleMaintenance.Variable = {};
	    self.spec_ExtendedVehicleMaintenance.Variable = 30.0;
	
	    self.spec_ExtendedVehicleMaintenance.VariableWartezeit = {};
	    self.spec_ExtendedVehicleMaintenance.VariableWartezeit = 60;
	   
	    self.spec_ExtendedVehicleMaintenance.CurrentMinuteBackup = {};
	    self.spec_ExtendedVehicleMaintenance.CurrentMinuteBackup = g_currentMission.hud.environment.currentMinute;
		
		self.spec_ExtendedVehicleMaintenance.Minus = {};
	    self.spec_ExtendedVehicleMaintenance.Minus = 30;
		
		self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt = {};
	    self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt = false;
		
		self.spec_ExtendedVehicleMaintenance.Differenz = {};
	    self.spec_ExtendedVehicleMaintenance.Differenz = 0;
		
	-- days	
		self.spec_ExtendedVehicleMaintenance.Days = {};
	    self.spec_ExtendedVehicleMaintenance.Days = 36;
		
		self.spec_ExtendedVehicleMaintenance.BackupAge = {};
	    self.spec_ExtendedVehicleMaintenance.BackupAge = 0;
	end;
end;

function ExtendedVehicleMaintenance:onUpdate(dt)
    if self.typeName == "FS19_ExtendedVehicleMaintenance.palletMaintencance" then -- searches for the Pallet
	    rootNodePallet = self.rootNode;
	end;
	self:raiseActive() 	

    if self.spec_motorized ~= nil and self.typeName ~= locomotive then
        if self:getIsActive() and self.spec_ExtendedVehicleMaintenance.Variable < 0.05 or self.spec_ExtendedVehicleMaintenance.Days <= 0 then -- checks if a value is under 0 
	        Wartung = 1
	    end;
	    if self:getIsActive() and self.spec_ExtendedVehicleMaintenance.Variable >= 0.05 and self.spec_ExtendedVehicleMaintenance.Days > 0 then 
	        Wartung = 1 - 1
	    end;
        if self:getIsActive() and Wartung == 0 then
	        g_currentMission:addExtraPrintText(g_i18n:getText("information_Motor"):format(self.spec_ExtendedVehicleMaintenance.Variable, self.spec_ExtendedVehicleMaintenance.Days)) -- 110n Text
	    end;
     
	    --hours 
		if self:getIsActive() then
	        self.spec_ExtendedVehicleMaintenance.Variable = self.spec_ExtendedVehicleMaintenance.Minus - self:getFormattedOperatingTime() + self.spec_ExtendedVehicleMaintenance.Differenz -- Operating time number 
	    --days 
		    self.spec_ExtendedVehicleMaintenance.Days = 36 + self.spec_ExtendedVehicleMaintenance.BackupAge - self.age -- day number
        end;
		
        -- Action if number is 0	
	    if self:getIsActive() and Wartung == 1 then
	        g_currentMission:addExtraPrintText(g_i18n:getText("warning_wartung"))
		    self.spec_motorized.motor.gearChangeTime = 400
		    self.spec_motorized.motor.accelerationLimit = 100
		    self.spec_motorized.motor.torqueCurve.maxTime = 3000
    	end;
	
	    -- looks for the position of the pallet and adds the action event
	    if self:getIsActive() and g_currentMission.nodeToObject[rootNodePallet] ~= nil then 
	        local px, py, pz = getWorldTranslation(rootNodePallet) -- Palette
	    	local vx, vy, vz = getWorldTranslation(self.rootNode) -- Fahrzeug
		 
	        if MathUtil.vector3Length(px-vx, py-vy, pz-vz) > 6 then 
		        Check2 = 1 - 1
		    end;
	        if MathUtil.vector3Length(px-vx, py-vy, pz-vz) < 6 and Check2 == 0 and Wartung == 1 then
	            local spec = self.spec_ExtendedVehicleMaintenance;
	            spec.actionEvents = {};
	            self:clearActionEventsTable(spec.actionEvents);
	
	
                local _, actionEventIdWartung = self:addActionEvent(spec.actionEvents, InputAction.VEHICLE_MAINTENANCE, self, ExtendedVehicleMaintenance.VEHICLE_MAINTENANCE, false, true, false, true, nil);
		
                g_inputBinding:setActionEventTextPriority(actionEventIdWartung, GS_PRIO_NORMAL)
			    Check2 = 0 + 1
			    test = 0 + 1
		    elseif MathUtil.vector3Length(px-vx, py-vy, pz-vz) > 6 and test == 1 and self.spec_ExtendedVehicleMaintenance.actionEvents ~= nil then
		        local spec = self.spec_ExtendedVehicleMaintenance;
		        self:removeActionEvent(spec.actionEvents, InputAction.VEHICLE_MAINTENANCE)
		        test = 1 - 1
		    end;
	    end;
	   
	    -- action if action event input is pressed
	    if self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt == true then
		    local spec = self.spec_ExtendedVehicleMaintenance
		    if g_currentMission.missionInfo.automaticMotorStartEnabled == true then
	            self.spec_enterable.isControlled = false
	        elseif g_currentMission.missionInfo.automaticMotorStartEnabled ~= true then
	            self:stopMotor()
	        end;
			-- subtracts the time from the 1 hour 
	        if self.spec_ExtendedVehicleMaintenance.CurrentMinuteBackup ~= g_currentMission.hud.environment.currentMinute then
			    self.spec_ExtendedVehicleMaintenance.CurrentMinuteBackup = g_currentMission.hud.environment.currentMinute
				self.spec_ExtendedVehicleMaintenance.VariableWartezeit = self.spec_ExtendedVehicleMaintenance.VariableWartezeit - 1
			end;
			if self:getIsActive() then
			    g_currentMission:addExtraPrintText(g_i18n:getText("information_wartung"):format(self.spec_ExtendedVehicleMaintenance.VariableWartezeit))
			end;
			self:removeActionEvent(spec.actionEvents, InputAction.VEHICLE_MAINTENANCE)
	    end;
		-- action if 1 hour is over 
		if self.spec_ExtendedVehicleMaintenance.VariableWartezeit <= 0 and self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt == true then
		    self.spec_ExtendedVehicleMaintenance.Minus = self.spec_ExtendedVehicleMaintenance.Minus + 30
			self.spec_ExtendedVehicleMaintenance.Differenz = self:getFormattedOperatingTime() - (self.spec_ExtendedVehicleMaintenance.Minus - 30)
			self.spec_ExtendedVehicleMaintenance.BackupAge = self.age
			self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt = false
		end;
	end;
end;    

function ExtendedVehicleMaintenance:VEHICLE_MAINTENANCE()
	self.spec_motorized.motor.gearChangeTime = self.spec_ExtendedVehicleMaintenance.gearChangeTimeBackup
    self.spec_motorized.motor.accelerationLimit = self.spec_ExtendedVehicleMaintenance.accelerationLimitBackup
	self.spec_motorized.motor.torqueCurve.maxTime = self.spec_ExtendedVehicleMaintenance.torqueCurveBackup
	self.spec_ExtendedVehicleMaintenance.VariableWartezeit = 60
	self.spec_ExtendedVehicleMaintenance.CurrentMinuteBackup = g_currentMission.hud.environment.currentMinute
	self.spec_ExtendedVehicleMaintenance.WartungKnopfGedrückt = true
end;	
